import java.io.*;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class BankAccountTest extends TestCase {
	public BankAccount ba;

	public BankAccountTest(String name){
		super(name);
	}
	
	/*
	 * @see TestCase#setUp()
	 */
	public void setUp() throws Exception {
		ba=new BankAccount(300,700,-200);
		
	}

	/*
	 * @see TestCase#tearDown()
	 */
	
	public void tearDown() throws Exception {
		super.tearDown();
	}
	
	public String[]loadFile(){
		String str=null;
		String[] s= new String[5];
		int j=0;
		int k=0;
		int i;
		int counter=0;
		try {
    		DataInputStream dis=
    			new DataInputStream(new FileInputStream("testCase.txt"));
    		byte[] data=new byte[dis.available()];
    		dis.readFully(data);
    		str=new String(data);
    		for (i=1;i<=str.length();i++){
    			if(str.substring(j,i).equals(";")){
    				s[counter]=str.substring(k,j);
    				counter++;
    				k=i;
    			}
    			j++;
    		}
    	}
    	catch(FileNotFoundException fnfe){
    		System.out.println("E");
    	}
    	catch(IOException ioe){
    		System.out.println("E1");
    	}
    	return s;
	}
	/*
	 * TestCase for testing methods
	 */
    public void testWithdraw(){
    	String sAmound=null;
    	sAmound=loadFile()[1];
    	double balance=ba.getBalance();
    	double amound=Double.parseDouble(sAmound);
        ba.withdraw(amound);
        System.out.println("Normal withdraw: "+ba.getBalance());
        assertTrue(ba.getBalance()==balance-amound);
    }
    
    public void testDeposit(){
    	String sAmound=null;
    	sAmound=loadFile()[4];
    	double balance=ba.getBalance();
    	double amound=Double.parseDouble(sAmound);
    	ba.deposit(amound);
    	System.out.println("Normal deposit: "+ba.getBalance());
    	assertTrue(ba.getBalance()==balance+100);
    }
    
    public void testWithdrawLimit(){
    	try {
    		String sAmound=null;
        	sAmound=loadFile()[3];
        	double amound=Double.parseDouble(sAmound);
    		ba.withdraw(amound);
    		System.out.println("bigger than limited withdraw: "+amound);
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Withdraw failed (limit), Balance is:"+ba.getBalance());
		}
    }
    
    public void testWithdraw0(){
    	try {
    		ba.withdraw(0);
    		System.out.println("=0 withdraw: "+ba.getBalance());
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Withdraw failed (0 amound), Balance is:"+ba.getBalance());
		}
    }
    
    public void testDeposit0(){
    	try {
    		ba.deposit(0);
    		System.out.println("=0 deposit: "+ba.getBalance());
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Deposit failed (0 amound), Balance is:"+ba.getBalance());
		}
    }
    
    public void testWithdrawSmaller0(){
    	try {
    		String sAmound=null;
        	sAmound=loadFile()[0];
        	double amound=Double.parseDouble(sAmound);
    		ba.withdraw(amound);
    		System.out.println("<0 Withdraw: "+ba.getBalance());
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Withdraw failed (<0 amound), Balance is:"+ba.getBalance());
		}
    }
    
    public void testDepositSmaller0(){
    	try {
    		String sAmound=null;
        	sAmound=loadFile()[0];
        	double amound=Double.parseDouble(sAmound);
    		ba.deposit(amound);
    		System.out.println("<0 deposit: "+ba.getBalance());
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Deposit failed (<0 amound), Balance is:"+ba.getBalance());
		}
    }
    public void testWithdrawLowest(){
    	try {
    		String sAmound=null;
        	sAmound=loadFile()[2];
        	double amound=Double.parseDouble(sAmound);
    		ba.withdraw(amound);
    		System.out.println("Lowerst withdraw: "+ba.getBalance());
    		fail("not failed");
		}
		catch (IllegalArgumentException e) {
			System.out.println("Withdraw failed (lowestbalance), Balance is:"+ba.getBalance());
		}
    }
    
    /*public static Test suite(){
    	TestSuite suite = new TestSuite();
    	suite.addTest(new BankAccountTest("testWithdraw"));
    	suite.addTest(new BankAccountTest("testLowest"));
    	suite.addTest(new BankAccountTest("testLimit"));
    	return suite;
    }*/
 
    /*
	 * Running the test
	 */
    //public static void main(String[] args) {
		//junit.textui.TestRunner.run(BankAccountTest.class);
	//}
}